Bug 3967 - CAMPAIGN: WS-GRAM TeraGrid SoftEnv Extensions
: CAMPAIGN: WS-GRAM TeraGrid SoftEnv Extensions
Status: RESOLVED FIXED
: GRAM
wsrf scheduler interface
: development
: PC Linux
: P3 normal
: 4.2
Assigned To:
:
:
:
: 4048
  Show dependency treegraph
 
Reported: 2005-12-01 18:58 by
Modified: 2007-08-22 15:29 (History)


Attachments


Note

You need to log in before you can comment on or make changes to this bug.


Description From 2005-12-01 18:58:17
Title: WS-GRAM TeraGrid SoftEnv Extensions

Projects: TeraGrid

	
Technologies:	Globus Resource Allocation Manager (GRAM)


Definition:

TeraGrid has specifically asked for support in GRAM for specifying SoftEnv
commands that configure the software environment for the job process. TeraGrid
has requested that this be done by early December, and as such a more general
framework for specifying software environment requriemnts is not the intention
of this campaign. The request specifies that some mechanism should be employed
to invoke SoftEnv commands before the job process is started with the intent of
setting up the job process's software environment. An extension to the job
description as well as LSF, PBS, and Fork Perl resource manager adapter support
for such extensions is proposed. TeraGrid also uses Condor, but the method for
transmitting SoftEnv commands to Condor jobs has not be defined in TeraGrid's
requirements and will be the subject of a future campaign.

Since LSF and PBS use an extended shell script format for their job description
documents, this can be accomplished by simply adding commands before the
executable. For Fork, though, a wrapper script will be needed. This feature is
designed for distribution only to TeraGrid, and as such will not be part of the
main CVS branches. Any future endeavor to create a general framework for
specifying software environemnt requirements will deprecate this campaign.

The schema for the extension element for software selection shall be as follows:

<element name="softenv" type="xsd:string">

For example, to add the SoftEnv commands "@teragrid-basic", "+intel-compilers",
"+mpich-gm-1.2.5..14b-intel-r1", "+atlas", and "+tgcp" to the job process's
environent, the user would specify the following "extensions" element in the job
description:

<extensions>
  <softenv>@teragrid-basic</softenv>
  <softenv>+intel-compilers</softenv>
  <softenv>+mpich-gm-1.2.5..14b-intel-r1</softenv>
  <softenv>+atlas</softenv>
  <softenv>+tgcp</softenv>
</extensions>


Deliverables:

1) LSF, PBS, and Fork update packages for 4.0.1 containing support for the
"softenv" extension element.
2) Documentation for 4.0.1 indicating how to install and use the update packages
(not published with main doc).

Tasks:

1) Add support to the PBS adapter perl module to append appropriate SoftEnv
commands to the job script.
2) Add support to the LSF adapter perl module to append appropriate SoftEnv
commands to the job script.
3) Add support to the Fork adapter perl module to create a job process wrapper
script and append appropriate SoftEnv commands to that script.
4) Generate a new globus_gram_job_manager_setup_pbs update package
5) Generate a new globus_gram_job_manager_setup_fork update package
6) Create 4.0.1 documentation describing how to install and use the update packages.

Time Estimate:

7 days
------- Comment #1 From 2005-12-01 19:00:09 -------
Completed support for SoftEnv in the PBS adapter. I created a branch off of the
trunk name "gram_softenv_branch" where this code will reside.
------- Comment #2 From 2005-12-02 16:51:06 -------
PBS, LSF, and Fork update packages are available here:

http://www-unix.mcs.anl.gov/~lane/Globus/TeraGrid.html

This completes all tasks but #6.

A task for the LSF update package was accidentally left out of the campaign
description. That would-be task is also completed.
------- Comment #3 From 2005-12-07 12:45:21 -------
I documentation blurb was added to the TeraGrid.html document mentioned in
comment #2 yesterday, so the campaign should have been closed. Closing now...